package com.qmth.distributed.print.business.bean.params;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

/**
 * @Description: 分配班级参数
 * @Author: CaoZixuan
 * @Date: 2024-03-07
 */
public class AssignClazzParam {
    @ApiModelProperty("考试id")
    @JsonSerialize(using = ToStringSerializer.class)
    @NotNull(message = "请选择考试")
    @Range(min = 1L, message = "请选择考试")
    private Long examId;

    @ApiModelProperty("课程编号")
    private String courseCode;

    @ApiModelProperty("教师id")
    @JsonSerialize(using = ToStringSerializer.class)
    @NotNull(message = "请选择教师")
    @Range(min = 1L, message = "请选择教师")
    private Long teacherId;

    @ApiModelProperty("班级集合")
    @JsonSerialize(using = ToStringSerializer.class)
    @NotEmpty(message = "请选择班级")
    @Size(min = 1, message = "请选择班级")
    private List<Long> clazzIdList;

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public Long getTeacherId() {
        return teacherId;
    }

    public void setTeacherId(Long teacherId) {
        this.teacherId = teacherId;
    }

    public List<Long> getClazzIdList() {
        return clazzIdList;
    }

    public void setClazzIdList(List<Long> clazzIdList) {
        this.clazzIdList = clazzIdList;
    }
}
