package com.qmth.distributed.print.business.bean.params;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotNull;

/**
 * @Description: 教师团队参数
 * @Author: CaoZixuan
 * @Date: 2023-03-16
 */
public class TeacherTeamParam {

    @ApiModelProperty("姓名")
    @NotNull(message = "请填写姓名")
    @Length(message = "请填写姓名")
    private String teacherName;

    @ApiModelProperty("工号")
    @NotNull(message = "请填写工号")
    @Length(message = "请填写工号")
    private String teacherCode;

    @ApiModelProperty("基础课程id")
    @NotNull(message = "缺少考试")
    @Range(min = 1L, message = "缺少考试")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long examId;

    @ApiModelProperty("课程编号")
    @NotNull(message = "缺少课程编号")
    @Length(min = 1, message = "缺少课程编号")
    private String courseCode;

    public String getTeacherName() {
        return teacherName;
    }

    public void setTeacherName(String teacherName) {
        this.teacherName = teacherName;
    }

    public String getTeacherCode() {
        return teacherCode;
    }

    public void setTeacherCode(String teacherCode) {
        this.teacherCode = teacherCode;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }
}
